`timescale 1ns / 1ps
module tb();
parameter W = 17;
parameter N = 512;

integer fid_wr;

function integer clogb2(input integer N);
        begin
                for(clogb2=0;N>1;clogb2=clogb2+1)
                        N = N >> 1;
        end
endfunction
GSR GSR(1'b1);
reg clk;
reg rstn;
wire signed [W-1:0]a;
wire signed [W-1:0]b;
wire complete;
wire [5:0] delay;
wire signed [2*W-1:0]result;

initial begin
        rstn = 1;
        #10 rstn = 0;
        #20 rstn = 1;
end
initial begin
        clk = 0;
end
always #10 clk = ~clk;

top uut
(
        .complete(complete),
        .delay(delay),
        .clk(clk),
        .rstn(rstn),
        .a(a),
        .b(b),
        .result(result)
);

always @(posedge clk) begin
	if (complete)begin
		$fdisplay(fid_wr,"%d",result);
	end
end

initial begin
	fid_wr = $fopen("data/result.dat", "w");
end

endmodule
