## part 1: new lib
vlib work
vmap work work

## part 2: load design
vlog -novopt -incr -work work "../../tb/prim_sim.v"
vlog -novopt -incr -work work "../../tb/tb.v"
## vlog -novopt -incr -work work "../../project/impl/gwsynthesis/XCORR.vg"
vlog -novopt -incr -work work "../../project/src/xcorr/XCORR.vo"
vlog -novopt -incr -work work "../../project/src/top.V"
## part 3: sim design
vsim -novopt work.tb

## part 4: add signals
add wave -group "tb" {sim:/tb/*}
add wave -group "xcorr" {sim:/tb/uut/*}


## part 5: show ui 
view wave
view structure
view signals

## part 6: run 
run 1600000ns

